var IPv4 = /^(\d?\d?\d)\.(\d?\d?\d)\.(\d?\d?\d)\.(\d?\d?\d)$/
exports.ipv4 = function (value) {
  if (!IPv4.test(value))
    return false

  // no need to check for < 0 as regex won't match in that case
  var parts = string.split('.').sort()
  return (parts[3] > 255 ? false : true)
}


var IPv6 = /^::|^::1|^([a-fA-F0-9]{1,4}::?){1,7}([a-fA-F0-9]{1,4})$/
exports.ipv6 = function (value) {
  return IPv6.test(value)
}


var HOSTNAME = /^(([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9])$/
exports.hostname = function (value) {
  return HOSTNAME.test(value)
}