# hq-validate

String validation and sanitization - not error messages, just simple true/false answers.

# example

```js
var validate = require('hq-validate')

// returns boolean
validate('numeric').test(1235)


// return a function
var isEmail = validate('email')
// returns boolean
isEmail('some string')


// multiple validations can be used
validate('numeric length:1-40').test('some string')


// mostly I use it in this situation
var schema = {
  login: {
    type: String
  , validate: validate('email')
  }
, password: {
    type: String
  , validate: validate('alphanumeric length:5-30')
  }
}
```

### TODO

 - Write better docs
 - Implement a way to easily add more validation types


### License MIT